#import "speak_b6.dll"
	bool gSpeak(string text, int rate, int volume);
#import

bool speak_once=true;
int iPeriod;
string sSymbol, sAudio;
//+------------------------------------------------------------------+
int init()
  {
   iPeriod=Period();
   sSymbol=Symbol();
   AudioString();
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
  if(speak_once) {
  gSpeak(sAudio+"Mac D! is Down",1,100); 
  gSpeak("Hurry up! Let's open BUY <pitch middle = '-10'/> position",1,100));
  
  speak_once=false;
  return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//+ Function called in init() to create string for audio "Symbol + TimeFrame" from Symbols_.csv in MQL4/Files
//+ Maintain in csv file: "Symbol as provided by the broker" , "Spoken text for this symbol", e.g.
//+      AUDUSD,Aussie
//+      EURUSD,Euro
//+		etc...
//+------------------------------------------------------------------+
void AudioString () {
    string sSymbols[][2];
    string sMsg;
    int x,i;
    
    x=StringArrayLoad("Symbols_.csv", sSymbols, 2);
    if(x<1) sMsg=StringConcatenate(sMsg,"Error "+GetLastError()+" reading file Symbols_.csv\n");  
    for(i=0; i<x; i++) {
      if(sSymbols[i][0]==sSymbol) break;
    }
    if(i<x) sAudio=sSymbols[i][1];
    else    {sMsg=StringConcatenate(sMsg,"Symbol not found\n");
             Alert(sMsg);
             }
    string sPeriods[9][2]={   //may need to add a line for non-stadard timeframes, as well as changle sPeriods[9][2] to sPeriods[10][2]
							  "1", "1 minute",
                              "5", "5 minutes",
                             "15", "15 minutes",
                             "30", "30 minutes",
                             "60", "1 hour",
                            "240", "4 hour",
                           "1440", "Daily",
                          "10080", "Weekly",
                          "43200", "Monthly"
						  
                         }; 
    for(i=0; i<9; i++)  {  //change i<9 to i< number of lines above as required
      if(sPeriods[i][0]==IntegerToString(iPeriod)) break;
    }
    if(i<9) {sAudio=StringConcatenate(sAudio," ",sPeriods[i][1]," ");
    //Print(sAudio);
    }
    else    {sMsg=StringConcatenate(sMsg,"Period not found\n");
             Alert(sMsg);
             }
  }

//+------------------------------------------------------------------+
//| StringArrayLoad()                                                |
//+------------------------------------------------------------------+
int StringArrayLoad(string sFile, string& A[][], int iColumns) 
  {
    int handle = FileOpen(sFile, FILE_CSV|FILE_READ, ";"), i, iStart, iPos;
//----
    if(handle < 1) 
      {
        Alert("File:", sFile, " error "+GetLastError());
        return(-1);
      }
    string sLine;
    int iRows = ArrayRange(A,0), iLinesRead = 0;
//----
    while(FileIsEnding(handle) == false) 
      {
        sLine = FileReadString(handle);
        iStart = StringLen(sLine);
        //----
        if(iStart < 1 || StringSubstr(sLine,0,2) == "//") 
            continue; // empty strings or comment lines dropped
        //----
        if(iLinesRead >= iRows) 
          {
            if(ArrayResize(A,iRows+1) == 0 ) 
              {
                Alert("StringArrayLoad() error ", GetLastError());
                return(-1);
              }
            iRows += 1;
          }
        //----
        if(StringFind(sLine, ",,", 0) >= 0 || StringSubstr(sLine, iStart - 1, 1) == ",") 
          {
            Alert("File:", sFile, " Line:", iLinesRead, " NULL value");
            break;
          }
        sLine = sLine + ",";
        iStart = 0;
        //----
        for(i = 0; i < iColumns; i++) 
          {
            iPos = StringFind(sLine, ",", iStart);
            A[iLinesRead][i] = StringSubstr(sLine, iStart, iPos - iStart);
            iStart = iPos + 1;
          }
        iLinesRead++;
      }
    FileClose(handle);
    return (iLinesRead);
  }

