//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2018, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 White
#property indicator_color4 White
#property indicator_color5 DodgerBlue
#property indicator_color6 Gold
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1

#import "speak_b6.dll"
	bool gSpeak(string text, int rate, int volume);
#import 


extern int p = 10;
extern int s = 5;
extern int cb = 1000;  //count bars
extern int ATR = 1000;
extern double distance = 1.0;//2.0;
extern int arrots = 15; //arrow gap
extern int barsig = 1;  //signal bar
extern bool useGV = false;
extern bool useTTS = true;
extern bool soundAlert = false;
extern string signal_buy= "ding_up.wav";
extern string signal_sell= "ding_dn.wav";

bool SoundBuy  = true;
bool SoundSell = true;
bool SoundArrDn = true; 
bool SoundArrUp = true;

double fx1[],fx2[],hp[];
double z1,z2,ki;
int fs, iPeriod, gv;
string gvn, sSymbol, sAudio;
double upper[],lower[];
double upar[],dnar[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
   SetIndexBuffer(0,fx1);
   SetIndexBuffer(1,fx2);
   SetIndexBuffer(2,lower);
   SetIndexBuffer(3,upper);

   SetIndexBuffer(4,upar);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,233);
   SetIndexBuffer(5,dnar);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,234);

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexBuffer(6,hp);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);



   ki=2.0/(p+1);

   gvn=_Symbol+"-"+IntegerToString(_Period)+"-snip";
   
   if(useTTS) {
   iPeriod=Period();
   sSymbol=Symbol();
   AudioString();
   }

   return(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   SetIndexDrawBegin(0,Bars-cb);
   SetIndexDrawBegin(1,Bars-cb);

   double avg;

   for(int i=cb; i>=0; i--)
     {
      fx1[i]=Close[i];
     }

   for(int m=0; m<=s; m++)
     {
      z1=fx1[0]; //close[0]
      for(i=0; i<=cb; i++)
        {
         z1=z1+(fx1[i]-z1)*ki;
         hp[i]=z1;
        }

      z2=fx1[cb];
      for(i=cb; i>=0; i--)
        {
         z2=z2+(fx1[i]-z2)*ki;
         fx1[i]=(hp[i]+z2)/2;
        }
     }

   fs=0;
   for(i=cb; i>=0; i--)
     {
      if(fx1[i]>fx1[i+1])
         fs=1; //higher close[0]
      if(fx1[i]<fx1[i+1])  //lower close[0]
        {if(fs==1) fx2[i+1]=fx1[i+1]; fs=2;}
      if(fs==2)
         fx2[i]=fx1[i];
      else
         fx2[i]=0.0;

      avg = iATR(NULL,0,ATR, i+10);
      upper[i] = hp[i] + distance*avg;
      lower[i] = hp[i] - distance*avg;

      if(Close[i+1+barsig]<upper[i+1+barsig] && Close[i+barsig]>upper[i+barsig])
         dnar[i] = High[i]+arrots*Point;
      else
         dnar[i] = EMPTY_VALUE;

      if(Close[i+1+barsig]>lower[i+1+barsig] && Close[i+barsig]<lower[i+barsig])
         upar[i] = Low[i]-arrots*Point;
      else
         upar[i] = EMPTY_VALUE;
     }
//manageAlerts ===
   string cond;  
     //buy
   if(upar[barsig] !=EMPTY_VALUE) {if(fx2[barsig]==0.0) {cond="below raising channel";
      gv=1;}
      else if(fx2[barsig]!=0.0) {cond="below falling channel";
      gv=2;}
      }
   else
      //sell
      if(dnar[barsig] != EMPTY_VALUE) {if(fx2[barsig]==0.0) {cond="above raising channel";
      gv=-1;}
      else if(fx2[barsig]!=0.0) {cond="above falling channel";
      gv=-2;}
      }
         
      else
         gv=0;
   if(useGV) GlobalVariableSet(gvn,gv); // gv values 1..2/-1..-2/0 
   if(gv>=1) {
               if(SoundBuy && useTTS) gSpeak(sAudio+", price is "+cond+". Analyze Buy.",1,100);
                  else if(SoundBuy && soundAlert) PlaySound (signal_buy);        
            SoundBuy = false; SoundSell = true;
            } 
  if(gv<=-1) {
               if(SoundSell && useTTS) gSpeak(sAudio+", price is "+cond+". Analyze Sell",1,100);
                  else if(SoundSell && soundAlert) PlaySound (signal_sell);        
            SoundSell = false; SoundBuy = true;
            } 
   
   return(0);
  }
//+------------------------------------------------------------------+
void AudioString () {
    string sSymbols[][2];
    string sMsg;
    int x,i;
    
    x=StringArrayLoad("Symbols_.csv", sSymbols, 2);
    if(x<1) sMsg=StringConcatenate(sMsg,"Error "+GetLastError()+" reading file Symbols_.csv\n");  
    for(i=0; i<x; i++) {
      if(sSymbols[i][0]==sSymbol) break;
    }
    if(i<x) sAudio=sSymbols[i][1];
    else    {sMsg=StringConcatenate(sMsg,"Symbol not found\n");
             Alert(sMsg);
             }
    string sPeriods[9][2]={   "1", "1 minute",
                              "5", "5 minutes",
                             "15", "15 minutes",
                             "30", "30 minutes",
                             "60", "1 hour",
                            "240", "4 hour",
                           "1440", "Daily",
                          "10080", "Weekly",
                          "43200", "Monthly"
                         }; 
    for(i=0; i<9; i++)  {
      if(sPeriods[i][0]==IntegerToString(iPeriod)) break;
    }
    if(i<9) {sAudio=StringConcatenate(sAudio," ",sPeriods[i][1]," ");
    //Print(sAudio);
    }
    else    {sMsg=StringConcatenate(sMsg,"Period not found\n");
             Alert(sMsg);
             }
  }

//+------------------------------------------------------------------+
//| StringArrayLoad()                                                |
//+------------------------------------------------------------------+
int StringArrayLoad(string sFile, string& A[][], int iColumns) 
  {
    int handle = FileOpen(sFile, FILE_CSV|FILE_READ, ";"), i, iStart, iPos;
//----
    if(handle < 1) 
      {
        Alert("File:", sFile, " error "+GetLastError());
        return(-1);
      }
    string sLine;
    int iRows = ArrayRange(A,0), iLinesRead = 0;
//----
    while(FileIsEnding(handle) == false) 
      {
        sLine = FileReadString(handle);
        iStart = StringLen(sLine);
        //----
        if(iStart < 1 || StringSubstr(sLine,0,2) == "//") 
            continue; // empty strings or comment lines dropped
        //----
        if(iLinesRead >= iRows) 
          {
            if(ArrayResize(A,iRows+1) == 0 ) 
              {
                Alert("StringArrayLoad() error ", GetLastError());
                return(-1);
              }
            iRows += 1;
          }
        //----
        if(StringFind(sLine, ",,", 0) >= 0 || StringSubstr(sLine, iStart - 1, 1) == ",") 
          {
            Alert("File:", sFile, " Line:", iLinesRead, " NULL value");
            break;
          }
        sLine = sLine + ",";
        iStart = 0;
        //----
        for(i = 0; i < iColumns; i++) 
          {
            iPos = StringFind(sLine, ",", iStart);
            A[iLinesRead][i] = StringSubstr(sLine, iStart, iPos - iStart);
            iStart = iPos + 1;
          }
        iLinesRead++;
      }
    FileClose(handle);
    return (iLinesRead);
  }

